package sk.codeblog.seccam;

import android.util.Log;

import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Properties;
import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.activation.FileDataSource;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Multipart;
import javax.mail.PasswordAuthentication;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;

public class GMailer extends Thread {

    private static final String TAG = "GMailer";

    private String _text = "";
    private String _attachment = "";

    public GMailer(String Attachment) {
        _text = GetActualDateTime();
        _attachment = Attachment;
    }

    private String GetActualDateTime()
    {
        return (new SimpleDateFormat("dd.MM.yyyy HH:mm:ss")).format(new Date());
    }

    @Override
    public void run() {
        Properties props = new Properties();
        props.put("mail.smtp.auth", "true");
        props.put("mail.smtp.starttls.enable", "true");
        props.put("mail.smtp.host", "smtp.gmail.com");
        props.put("mail.smtp.port", "587");

        Session session = Session.getInstance(props,
                new javax.mail.Authenticator() {
                    protected PasswordAuthentication getPasswordAuthentication() {
                        return new PasswordAuthentication(Config.MailFrom, Config.MailPassword);
                    }
                });
        try {
            Message message = new MimeMessage(session);
            message.setFrom(new InternetAddress(Config.MailFrom));
            message.setRecipients(Message.RecipientType.TO, InternetAddress.parse(Config.MailTo));
            message.setSubject(Config.MailSubject);
            message.setText(_text);

            Multipart multipart = new MimeMultipart();

            MimeBodyPart messageBodyPart = new MimeBodyPart();

            File AttachFile = new File(_attachment);
            String fileName = AttachFile.getName();

            DataSource source = new FileDataSource(_attachment);
            messageBodyPart.setDataHandler(new DataHandler(source));
            messageBodyPart.setFileName(fileName);
            multipart.addBodyPart(messageBodyPart);

            message.setContent(multipart);

            Transport.send(message);

            //Vymaz odoslaneho suboru
            (new File(_attachment)).delete();


        } catch (MessagingException e) {
            Log.e(TAG, e.getMessage());
        }catch (Exception GenEx)
        {
            Log.e(TAG, GenEx.getMessage());
        }
    }
}
